#include "position.h"

#include <stdio.h>
#include <stdlib.h>

typedef struct fpos {
  unsigned long pos;
  const char *file;
  struct fpos *next;
} fpos;

static unsigned long pos;

static fpos *head;
static fpos *tail;

void enqueue(const char *f, unsigned long pos)
{
  fpos *p = malloc(sizeof(fpos));
  if (!p) { printf("ERROR: cannot enqueue %s\n", f); return; }
  p->pos = pos;
  p->file = f;
  p->next = 0;
  if (tail) tail->next = p;
  if (!head) head = p;
  tail = p;
}

void dequeue(void)
{
  if (tail == head) tail = 0;
  if (head) { fpos *n = head->next; free(head); head = n; }
}

void position_next_file(const char *f, unsigned long pos)
{
  enqueue(f, pos);
  advance_position(0);
}

void clear_song_pos(void);

void advance_position(unsigned long l)
{
  pos += l;
  while (head && pos >= head->pos) {
    printf("\nplaying %s\n", head->file);
    dequeue();
    clear_song_pos();
  }
}
